%{
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

#include "struct.h"

extern Record rules[Rsize];

extern int rules_num;
extern int lextime;

unsigned int line_num = 1;
int rule_id;

%}

Digit                [0-9]+

%x TOKEN
%x COUNT
%x OPTION

%%

%{
/* This is the init part of the yylex()    */
/* White space and EOL is important to lex */


%}
\n                 {
                     line_num++; 
                   }
.                  ;

"%%"               {
                     /*
                     printf("rule list begin\n");
                     */
                     BEGIN TOKEN;
                   }

<TOKEN>("R"|"H"){Digit}  {
                     /*
                     printf("find fule %s\n", yytext);
                     */
                     rules_num++;
                     memcpy(rules[rules_num].name, yytext, strlen(yytext)+1);
                   }

<TOKEN>{Digit}     {
                     /*
                     printf("find number %s", yytext);
                     */
                     rules[rules_num].number=atoi(yytext);
                     /*
                     printf(" %d\n", rules[rules_num].number);
                     */ 
                   }

<TOKEN>\n          {
                     line_num++;
                   }

<TOKEN>"/*"        { /* eat up comments, keep line number record */
                     int c;
                     for(;;){
                       while((c=input())!='*' && c!='\n' && c!= EOF);
                       if (c=='*'){
                         while((c=input())=='*');
                         if (c=='/') break;
                       }
                       if (c=='\n') line_num++;
                       if(c==EOF) exit(0);
                     }
                   }

<TOKEN><<EOF>>     {
                     BEGIN COUNT;
                     /*printf("file ends here\n");*/
                     return (1);
                   };

<TOKEN>.           ;


<COUNT>("R"|"H"){Digit} {
                     int i;
                     for (i=1; i<=rules_num; i++)
                       {
                         if (strcmp(rules[i].name, yytext)==0)
			   break;
                       };
                     rule_id=i;
                     /*printf("conting option\n");*/
                     BEGIN OPTION;
                   }
<COUNT>\n          ;
<COUNT>.           ;

<OPTION>"/"{Digit} {
                     rules[rule_id].option[atoi(yytext+1)]++;
                     BEGIN COUNT;
                   }
<OPTION>[ ]        {
                     rules[rule_id].option[1]++;
                     BEGIN COUNT;
                   }
<OPTION>\n         {
                     BEGIN COUNT;
                   }
<OPTION>.          {
                     BEGIN COUNT;
                   }


%%

yywrap()
{
  return(1);
}







